#include "cl_id10.h"
//v2.33 14.01.2009 .   / 
//v2.32 09.12.2008
//v2.32 05.12.2008 .     EEP;  .    ().
//v2.3 17.11.2008  ,   (9 ). 
//v2.2 11.11.2008     .
//v2.1 04.12.07

//**************************************
ISR(SIG_OVERFLOW0){
	if (++lcd_time_switch==light_isr)
		PORTLCD=lcd_buffer[znakomesto];
}
//**************************************
ISR(SIG_OVERFLOW2)
{
 clock_++;
 if (clock_==128)
	{	   	 		  	   	  				   	
	clock_=correct;
	isr_1sek_=1;
  	}
}

//--------------------------------------
void port_init(void)
{
DDRLCD=0xFF;
DDRID =pin_id;
DDR_VCC_ID |= PIN_VCC_ID;
PORT_VCC_ID|= PIN_VCC_ID;
DDR_OUT|=PIN_calls1 | PIN_calls_osn | PIN_timer;
PORT_POWER_DETECT|=_power_;
}
//**************************************
void timer0_init(void){
	TCCR0=0x01;
}
//**************************************
void timer2_init(void)
{
 TCCR2 = 0x00; 		  //stop
 ASSR  = (1<<AS2);	  //set async mode
 TCCR2 = 0x01; 		  //start
}
//**************************************
void timer1_init(void)
{
 TCCR1B = 0; //stop
 TCCR1A	= 0;
 OCR1AH = setup.ocr1[ocr1ahi];
 OCR1AL = setup.ocr1[ocr1alow];
 DDR_OC1A  &=~ OC1A;	  //OC1A 
}
//**************************************
void timer1_init_in_pwm(void)
{
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
}
//**************************************	
void shim_true(void){
	timer1_init_in_pwm();
	TCCR1B=(1<<CS10)|(1<<WGM12);
}
//**************************************

void init_devices(void)
{
 cli(); //disable all interrupts
 port_init();
 timer0_init();
 timer1_init();
 MCUCR = 0x00;
 GICR  = 0x00;
 ACSR=BIT(ACD);
 TIMSK =(1<<TOIE2)|(1<<TOIE0); //(1<<OCIE2)| timer interrupt sources |(1<<OCIE1A)
 sei(); //re-enable interrupts
}

// ***********************************************************
//void clear_adres_eeprom(void)
//{
// 	EEARH=0x01;
//	EEARL=0xFF;
//}
//**************************************
//   
unsigned char EEPROM_READ(unsigned int uiAddress)
{
	/*     */
	while(EECR & (1<<EEWE));
	/*    */
	EEAR = uiAddress;
	/*       EERE */
	EECR |= (1<<EERE);
	/*      */
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		/*     */
		while(EECR & (1<<EEWE));
		cli();
		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		sei();
		}
	//clear_adres_eeprom();
}

//*********************************************
void light_init(void){
	setup.day_light	=7;
	setup.night_light	=3;
	setup.tim_c_light	=23;
	setup.tim_do_light	=6;
}

void read_data_EEPROM(void)
{
unsigned char  *a, i;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=0 ; i<sizeof(setup); i++, a++){
		*a=EEPROM_READ(i);
		if (i<sizeof(setup)-2){
			crc+=*a;
			}
		}
	if ( crc!=setup.crc ) {
		eeprom_err=1;
		}
	if ( setup.day_light>sizeof(light_disp) ) light_init();
}

void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p;
 
	//if (time_flag & fl_eeprom_write)
	{
	//time_flag&= ~fl_eeprom_write;
	setup.crc=eeprom_err=0;
	TIMSK &=~(1<<TOIE0);//   ""   
	PORTLCD=0;
	p=(unsigned char *) &setup;
	for(i=0; i<sizeof(setup) ; i++, p++){
		EEPROM_write( i, *p );
		if (i<sizeof(setup)-2)
			setup.crc+=*p;
		}
	TIMSK |= (1<<TOIE0);
	}
}
//*********************************************


//*************** 1 Wire DALLAS ************************************************

void pullup_off(void){
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	PORT_1wire&=~pwire0;
	PORT_1wire&=~pwire1;
}
//***********************************************
unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down

//	asm("nop");
	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~out_1wire;//line up through 1.25us
	_delay_us(12);//11
	i=PIN_1wire;
	sei();
	_delay_us(47);//47
	return i;
}
//***********************************************
void readbyte(uint8_t *pw) {  
unsigned char read_byte[2]={0,0};//,i, r,  pinwire;

pullup_off();
for(uint8_t i=0, r=1; i<8; i++){
	uint8_t pinwire=readbit();
	if ( pinwire & pwire0 ) read_byte[0]|=r;
	if ( pinwire & pwire1 ) read_byte[1]|=r;
	r<<=1;
	}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
pw[0]=read_byte[0];	
pw[1]=read_byte[1];
}
//----------------------------------------------
void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);
	DDR_1wire&=~out_1wire;
	sei();
}
//***********************************************
void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(58);
}
//***********************************************
void writebyte(unsigned char byte){
unsigned char i;
pullup_off();
	for(i=0; i<8; i++){
		if (byte&BIT(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
}

//****************************************

void detectPresence(void){
unsigned char i;

	pullup_off();
	out_1wire=pwire0|pwire1;
	
	DDR_1wire|=pwire0;
	DDR_1wire|=pwire1;
	
	_delay_ms(0.48);
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	
	cli();
	_delay_us(60);
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) out_1wire&=~pwire0;
	if ( i & pwire1 ) out_1wire&=~pwire1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & pwire0 )) out_1wire&=~pwire0;
	if (!( i & pwire1 )) out_1wire&=~pwire1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
			
	power_suplly_1w &= out_1wire;
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;	
}

//****************************************
void scratchpad_save(void){

		detectPresence();//  
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(5);//	TH
		writebyte(5);//	TL
		writebyte(0x7f);//	Statys 12bit
		
		detectPresence();//   EEPROM
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x48);//COPY SCRATCHPAD [48h]
		
		PORT_1wire|=power_suplly_1w;
		DDR_1wire|=power_suplly_1w;
}
//****************************************
void izmerenie_t(void){

if (!regim)//       
	{
	if ( !count_com_1w ){//
		count_com_1w++;
		detectPresence();//  
		return;
		}

	if ( count_com_1w == 1 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xB4);//READ POWER SUPPLY [B4h]
		pullup_off();
		power_suplly_1w=readbit();//     
		power_suplly_1w=~power_suplly_1w;//    ,  
		power_suplly_1w &= out_1wire;//pwire0|pwire1;
		if  (power_suplly_1w) time_1w_flag|=BIT(fl_parasite_power);
			else time_1w_flag&=~BIT(fl_parasite_power);
		PORT_1wire|=power_suplly_1w;
		DDR_1wire|=power_suplly_1w;
		return;
		}

	if ( count_com_1w == 2 ){	// 
		count_com_1w++;
		detectPresence();//
		return;
		}

	if ( count_com_1w == 3 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		time[wire1]=127;//1sek
		return;
		}

	if ( count_com_1w == 4 ){
		if (time[wire1]<-15) count_com_1w++;
		return;
		}

	if ( count_com_1w == 5 ){// 
		count_com_1w++;
		detectPresence();//
		return;
		}

	if ( count_com_1w == 6 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		return;
		}

	if ( count_com_1w == 7 ){
		count_com_1w=0;
		readbyte(tempir_lsb);// 
		readbyte(tempir_msb);
		}

	}
}
//***********************************************/
//*************** END 1 Wire ***************************************************
void change_light_var(void)
{
		if ( time_flag & fl_plus )
		   {
		   if (++change_light>=lcd_light) time_flag &= ~fl_plus;//    
		   }
		   else
		   {
		   if (change_light>1) change_light--; else time_flag|= fl_plus;//  
		   }
}
//**************************************
uint8_t opred_light_current_num(void)
{
  char l;
  unsigned int a=0x100;
 	
	l=lcd_light;

	if (mask)
	 	{
		a>>=znakomesto;
		if ( mask&a ) l=change_light;
		}
		else	
		{
		time_flag &= ~fl_plus;
		change_light=lcd_light;
		}
	return l;
}

//**************************************
void display (void){
unsigned char tmp, zn;
	tmp=zn=znakomesto;
	tmp&=0x01;
	zn&=~0x01;
	zn<<=2;
	zn|=tmp;
	PORTID&=~pin_id;
	PORTID|=zn;
}

void button_signal(void){
if ( ( setup.ocr1[ocr1ahi_but] )||( setup.ocr1[ocr1alow_but] ) ){
	OCR1AH  = setup.ocr1[ocr1ahi_but];//0x04;
	OCR1AL  = setup.ocr1[ocr1alow_but];//0x00;
	shim_true();//
	time_flag|=fl_sig_butt;
	time[note_but]=7;
	}
}

void str_initread_port(void){
	DDRLCD =0xF0;
	PORTLCD=0x0F;
	_delay_us(15);
}

//**************************************
void skankey (void){
	unsigned char key_lokal=17;
	
	key=key_lokal;
	
	PORTID|=pin_id;
	str_initread_port();
	
	if (!str0)	    	key_lokal=0;
	else if (!str4)	key_lokal=4;
	else if (!str8)	key_lokal=8;
	else if (!str12)	key_lokal=12;
	else key_lokal=17;//goto vool;
/*	
	DDRLCD =0x0F;
	PORTLCD=0xF0;
	delay(15);
	
	if (!stolb1)		key_lokal+=1;
	else if (!stolb2)	key_lokal+=2;
	else if (!stolb3)	key_lokal+=3;
	else if (!stolb4)	key_lokal+=4;
	else
vool:	 key_lokal=17;
*/	
	if ( key_lokal!=17 )
	{
	anti_drebezg[0]++;
		if (anti_drebezg[0]==35)//35)
		{
		key=key_lokal;
		button_signal();
		}
		if (anti_drebezg[0]==anti_drebezg[2]){	//anti_drebezg[0]  
	   	   anti_drebezg[0]=0;					//anti_drebezg[1] -   
		   anti_drebezg[1]++;					//anti_drebezg[2]    
		   if (anti_drebezg[1]==4) anti_drebezg[2]=45;//55;
		   }	
	time_in_regim=25;
	}
	else
	{
	anti_drebezg[0]=0;
	anti_drebezg[1]=0;
	anti_drebezg[2]=200;
	}
	 
	PORTLCD=0x00;
	DDRLCD =0xFF;     
}

//**************************************
void inc_dec_var_bit(unsigned char *var,unsigned char bit_n){
	if (PLUS)	 (*var)|= BIT(bit_n);
	if (MINUS) 	 (*var)&=~BIT(bit_n);
}

//**************************************
void inc_dec_var(unsigned char *var, unsigned char limit){
	if (PLUS){
		if ((*var)<limit)	(*var)++; 
		else *var=0;
		}
	if (MINUS){
		if (*var) (*var)--;
		else *var=limit;
		}
}
//**************************************
void mask_next_regim(unsigned int m, unsigned char next_F,unsigned char SET)
{
 	if (!anti_drebezg[0])  mask=m; 
	if (F_)   regim=next_F;
	if (SET_) regim=SET;
	key=17;
}

void next_regim(void){
	if (PLUS) {
		if (regim<END_REGIM) 
		regim++;
		} 
	if (MINUS) {
		if (regim>FIRST_REGIM)
		regim--;
		} 
}

void reg_see_init(void){
	current_state_view.regim=0;
	current_state_view.time=3;
}

//**************************************
void key_action(void)
{//mask_next_regim( maska regima, if (key F_), if (key SET_) )

	mask=0;

	if (key!=17){
		if (!( (regim>=reg_signal+1)&&(regim<=reg_signal+2) ))
		if ( signal ){ 
			time_flag|= fl_signal_cls;
			time_flag&=~fl_signal_out_enable;
			if (F_) time_flag&= ~fl_sig_otsr;//        ,  
			regim=0;
			return;
			}
		}	

	if (!regim) {
		if (F_) {
			regim=REG_BUDILNIK;
			}
			else
		if (SET_){//    ?
		   regim=100;
		   }
		   else
		if (MINUS) regim=31;
			else
		if (PLUS) {
			regim=91;
			reg_see_init();
			}
		return;
		}
	
	if (regim==REG_BUDILNIK)	{ mask_next_regim(0xFFFF,REG_TIMER,31); return;}//calls	
	if (regim==REG_TIMER) 		{ mask_next_regim(0xFFFF,REG_SETUP,3); return;}//timer
	if (regim==REG_SETUP) 		{ mask_next_regim(0xFFFF,0,FIRST_REGIM);  return;}//setup

	if (regim==100) {//  set      100
		if ( (MINUS)||(PLUS) ) {
			time_flag&= ~fl_sig_otsr;//    
			regim=0;
			}
		mask_next_regim(0,0,0);
		return;
		}
	
	//___________________timer____________________
	 if (regim==3) {
		mask_next_regim(0,0,80);//t00-00-00
		return;
		}
	 if (regim==80) { //true chet timer
		if (key!=17) time_flag|= fl_signal_cls;//    
	 	inc_dec_var_bit(&timer[3], fl_timer_count);
		if (PLUS) regim=3;
		mask_next_regim(0b100000000,3,81);
		return;
	 	}
	 if (regim==81) {//set hour timer
	 	inc_dec_var(&timer[2],99);
	 	mask_next_regim(0b11000000,3,82);
		return;
		}
	 if (regim==82) {//set min timer
	 	inc_dec_var(&timer[1],59);
	 	mask_next_regim(0b11000,3,83);
		return;
		}
	 if (regim==83) {//set sek timer
	 	inc_dec_var(&timer[0],59);
	 	mask_next_regim(0b11,3,80);
		return;
		}	
	//----------------------------------------------
	 //CALLS//****************************
	 if (regim==31) {//set number calss
	 	inc_dec_var(&budilnik_nomer,11);
	 	mask_next_regim(0b100000000,0,32);
		p_index=0;
		return;
	 	}
	 if (regim==32) {//on off calls

	 	if (( budilnik_nomer >= 8 )&&( budilnik_nomer <= 9 )){
			if (p_index) 
				{
				inc_dec_var(&nedelia[budilnik_nomer-8],1);
				mask_next_regim(0b100000,31,33);
				return;
				}
			if (SET_) { p_index=1; return; }
			}
	
		if (MINUS)
			setup.budilnik[ budilnik_nomer ][c_sig]=0;
			
		if (PLUS)
		if ( ++setup.budilnik[ budilnik_nomer ][c_sig] > 4 ) 
				setup.budilnik[ budilnik_nomer ][c_sig]=0;	
		
		if ( budilnik_nomer > 9 ) 
			if ( setup.budilnik[ budilnik_nomer ][c_sig] > 0 ) 
				setup.budilnik[ budilnik_nomer ][c_sig]=2;
		
	 	mask_next_regim(0b11000000,31,33);
		return;
	 	}
	 if (regim==33) {//set hour calss
	 	inc_dec_var(&setup.budilnik[budilnik_nomer][c_hour],23);
	 	mask_next_regim(0b11000,31,34);
		return;
	 	}
	 if (regim==34) {//set min calls
	 	inc_dec_var(&setup.budilnik[budilnik_nomer][c_min],59);
		uint8_t a;
		if (budilnik_nomer<10) a=35; else a=45;
	 	mask_next_regim(0b11,31,a);
		return;// 
	 	}
	if  ( (regim>34)&&(regim<42) )
	for( uint8_t i=35,a=0; i<42 ;i++,a++){
	  if (regim==i) {//set day calss
			inc_dec_var_bit( &setup.budilnik[budilnik_nomer][h_day], a );
			mask_next_regim(BIT(6-a),31,i+1);
			break;
			}
		}
	if (regim==42) {//save current budilnik in eeprom
		//EEPROM_save_parametr_all();
		regim=31;
		return;
		}
	if (regim==45) {//set hour
		inc_dec_var(&setup.budil_pin[budilnik_nomer-10][h_hour],23); 
		mask_next_regim(0b11000000,31,46);
		return;
	 	}
	if (regim==46) {// set min
	 	inc_dec_var(&setup.budil_pin[budilnik_nomer-10][h_min],59);
		mask_next_regim(0b11000,31,47);//
		return;
	 	}
	if (regim==47) {// set min
	 	inc_dec_var(&setup.budil_pin[budilnik_nomer-10][h_sek],59);
		mask_next_regim(0b11,31,35);//
		return;
	 	}
	//************ end calls *****************	

	//-----------------PORT------------------1//120
	 if (regim==REG_PORT) {//120
		next_regim();
		mask_next_regim(0xFFFF,0,71);//Port  C	
		return;
		}
	 if (regim==71) {//_pin-0_ _c								   //A_0 E_0 C
	 	if (PLUS) PORT_OUT|=PIN_calls1;
		if (MINUS) PORT_OUT&=~PIN_calls1;
		mask_next_regim(0b10,REG_PORT,REG_PORT);
		return;
		}
	//--------------------END PORT-----------------

	//====================CLOCK====================2//121
	 if (regim==REG_CLOCK) {//121
		next_regim();
		mask_next_regim(0xFFFF,0,r_clock); 
		return; 
		}//clock 
		
	// 12-00-00
	if (regim==r_clock) {//set  sek
	 	if (MINUS){
		   if (hour[h_sek]>31) hour[h_min]++;
		   hour[h_sek]=0;
		   clock_=0;
		   }
	 	mask_next_regim(0b11,REG_CLOCK,r_clock+1);
		return;
		}	

 	if (regim==r_clock+1) {//set min
	 	inc_dec_var(&hour[h_min],59);
	 	mask_next_regim(0b11000,REG_CLOCK,r_clock+2);
		return;
		}
	if (regim==r_clock+2) {//set hour
		//time_light_global();
	 	inc_dec_var(&hour[h_hour],23);
	 	mask_next_regim(0b11000000,REG_CLOCK,r_clock+3);
		return;
		}
	
	// 28.07.08 
	if (regim==r_clock+3) {//set num 
	 	inc_dec_var(&hour[h_num],30);
	 	mask_next_regim(0x0180,REG_CLOCK,r_clock+4);
		return;
		}
	if (regim==r_clock+4) {// set month 
	 	inc_dec_var(&hour[h_month],11);
	 	mask_next_regim(0b1100000,REG_CLOCK,r_clock+5);
		return;
		}
	if (regim==r_clock+5) {// set  year
	 	inc_dec_var(&hour[h_year],99);
	 	mask_next_regim(0b11000,REG_CLOCK,r_clock+6);
		return;
		}
	if (regim==r_clock+6) {//set day
	 	inc_dec_var(&hour[h_day],7-1);
	 	mask_next_regim(0b11,REG_CLOCK,r_clock+7);
		return;
		}

	//  corection
	if (regim==r_clock+7) {//set corection znak
	 	inc_dec_var_bit(&setup.corr_flag, fl_corr_znak_pl);
	 	mask_next_regim(0x10,REG_CLOCK,r_clock+8);
		return;
		}
	 if (regim==r_clock+8) {//set corection
	 	inc_dec_var(&setup.correction,sizeof(corr_in_lcd)/2-1);
	 	mask_next_regim(0x0F,REG_CLOCK,REG_CLOCK);
		//if (regim==REG_CLOCK) {
		//	EEPROM_save_parametr_all();
		//	}
		return;
		}
	//-----------------end cklock-----------------------
	
	//SEE//*****************************
	if (regim==REG_YST_SEE){
		reg_see_init();
		next_regim();
		mask_next_regim(0xFFFF,0,91);//_t_SEE_
		return;
		}
	if (regim==91) {//F1 r.1-000 1 F0..0 00
	 	inc_dec_var( &current_state_view.regim, Count_regim-1);
	 	mask_next_regim(0b100000000,REG_YST_SEE,92);//BIT(8)
		return;
		}	
	if (regim==92) {//F1 r.1-000 
	 	inc_dec_var(&setup.state_regim[current_state_view.regim],num_formats);
	 	mask_next_regim(0b1000000,91,93);
		return;
		}	
	if (regim==93) {//r.1-000 F1
	 	inc_dec_var(&setup.state_time[current_state_view.regim],99);
	 	mask_next_regim(0b1100,91,94);
		//if (regim==91) EEPROM_save_parametr_all();
		return;
		}
	if (regim==94) {//F1 r.1-000 
	 	inc_dec_var(&setup.state_skip[current_state_view.regim],9);
	 	mask_next_regim(0b1,91,91);
		return;
		}
	
	//-------------END SEE----------------
	
	//-------------yct bud----------------
	if (regim==REG_YST_BUD) {//123
		next_regim();
		mask_next_regim(0xFFFF,0,75);//yct bud	
		return;
		}
	if (regim==75) {//CAL. bIP C
	 	inc_dec_var(&setup.signal_bud, 2);
		mask_next_regim(0x07,REG_YST_BUD,REG_YST_BUD);
		//if (regim==REG_YST_BUD) EEPROM_save_parametr_all();
		return;
		}
	//-------------------end___yct bud--------------------

	//-------------------light--------------------------//
	if (regim==REG_LIGHT) {//125
		next_regim();
		mask_next_regim(0xFFFF,0,11); 
		return; 
		}
	if (regim==11) {
	 	inc_dec_var(&setup.day_light,sizeof(light_disp)-1);
		//if (!setup.day_light) setup.day_light=1;
	 	mask_next_regim(0x100,REG_LIGHT,14);
		return;
		}
	if (regim==14) {
	 	inc_dec_var(&setup.night_light,sizeof(light_disp)-1);
		//if (!setup.night_light) setup.night_light=1;
	 	mask_next_regim(0b10,REG_LIGHT,15);//noch L.5
		return;
		}
	if (regim==15) {
		inc_dec_var(&setup.tim_c_light,23);
		mask_next_regim(0b1100000,REG_LIGHT,16);
		return;
		}
	if (regim==16) {
		inc_dec_var(&setup.tim_do_light,23);
		mask_next_regim(0b11,REG_LIGHT,REG_LIGHT);
		//if (regim==REG_LIGHT) EEPROM_save_parametr_all();
		return;
		}
	//---------------end__light--------------------
	
	//------------SIGHAL---------------------------
	if (regim==REG_SIGNAL){//124
		next_regim();
		mask_next_regim(0xFFFF,0,reg_signal);//SIGHAL
		return;
		}
	if (regim==reg_signal){
		inc_dec_var(&p_index,1);
		mask_next_regim(0b011111100,REG_SIGNAL,reg_signal+1);//budil button 
		time[note]=3;
		time_flag|= fl_signal_cls;
		//if (regim==REG_SIGNAL) EEPROM_save_parametr_all();
		return;
		}
	if (regim==reg_signal+1) {//H000 L000
	 	inc_dec_var(&setup.ocr1[p_index*2],0xFF);//ocr1ahi
	 	mask_next_regim(0b011100000,reg_signal,reg_signal+2);
		return;
		}
	if (regim==reg_signal+2) {//H000 L000 
	 	inc_dec_var(&setup.ocr1[p_index*2+1],0xFF);//ocr1alo
	 	mask_next_regim(0b000000111,reg_signal,reg_signal+1);
		return;
		}
	//-------------end__signal--------------

	//-------------ds18b20------------------
	if (regim==REG_DS18B20) {//126
		next_regim();
		mask_next_regim(0xFFFF,0,111);
		return; 
		}//ds18b20	
	if (regim==111) {
		inc_dec_var(&setup.vid_t,1);//ocr1ahi
		mask_next_regim(0x20,REG_DS18B20,112); 
		return;
		}
	if (regim==112) {
		mask_next_regim(0,REG_DS18B20,REG_DS18B20); 
		if (regim==REG_DS18B20) {
			PORTLCD=0;
			scratchpad_save();		 
			//regim=REG_DS18B20;
			}
		return;
		}
	//-----------end=ds18b20----------------
	
	//----------- ----------------
	if (regim==REG_SAVE_SETUP) {
	 	if (SET_){
			EEPROM_save_parametr_all();
			regim=0;
			}
			
		next_regim();
	 	mask_next_regim(0b111111111,0,0);
		return;
		}
	
	//----------------------------------
	if (regim==REG_SBROS_N) {
	 	if (SET_){
			uint8_t *p;
		   	p=(unsigned char *) &setup;
			for( uint8_t i=0; i<sizeof(setup) ; i++, p++)
				*p=0;
			light_init();
			setup.ocr1[ocr1ahi_but]=0x04;
			setup.ocr1[ocr1alow_but]=0x00;
			setup.ocr1[ocr1ahi]= 0x02;
			setup.ocr1[ocr1alow]=0x00;
			change_light=5;
			EEPROM_save_parametr_all();
			regim=0;
			}
			
		next_regim();
	 	mask_next_regim(0b111111111,0,0);
		return;
		}
	 //_______________________________________________
}

//**************************************
void result_in_bcd(int result)
{
    unsigned char dig_out=0;
	bcd_num0=0;
	bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;
	while (result >= 10000) {
	 result -= 10000;
 	 dig_out ++;
	}
	bcd_num0=dig_out;
    dig_out = 0;
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	bcd_num1=dig_out;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4=result;
}
//**************************************
void cls_lcd_buffer(void){
unsigned char i;
 for(i=0;i<9;i++){
	lcd_buffer[i]=0;
	}
}
//**************************************

//**************************************
void load_str_in_lcdbuffer1(prog_int8_t* str_lcd){
unsigned char b,e,length;//str_lcd[0] = 0000 1111-, 1111 0000 -  
	length=pgm_read_byte_near(&str_lcd[0]);
	for( b=0x0F&(length), e=1 ; b<(0x0F&(length>>4)) ; b++, e++){
		lcd_buffer[b]=pgm_read_byte_near(&str_lcd[e]);
		}
}
//**************************************
void num2_bcd_in_lcd(unsigned char znak_mesto, unsigned char param_out)
{
 	result_in_bcd(param_out);
	lcd_buffer[znak_mesto]=font[bcd_num3];
	lcd_buffer[znak_mesto+1]  =font[bcd_num4];
}
//**************************************
void blank_nul(unsigned char mesto){
 if (lcd_buffer[mesto]==font[n0]) 
	lcd_buffer[mesto]=0;
}

//**************************************
void clock_in_lcd_gl(unsigned char znakomesto)
{
 	num2_bcd_in_lcd(znakomesto,hour[h_hour]);
	blank_nul(znakomesto);
	#ifdef miganie
 	if ( time_flag & fl_sek_1_switch )
	#endif
	lcd_buffer[znakomesto+2]=font[f_seg_g];
	num2_bcd_in_lcd(znakomesto+3,hour[h_min]);
}
//**************************************
void clock_in_lcd0(void)
{
 	num2_bcd_in_lcd(0,hour[h_num]+1);
	lcd_buffer[1]|=font[tochka];
	result_in_bcd(hour[h_day]+1);
	lcd_buffer[2]=font[bcd_num4];
	clock_in_lcd_gl(4);
}
//**************************************
void day_str(void){
	lcd_buffer[7]=h_day_str[hour[h_day]*2];
	lcd_buffer[8]=h_day_str[hour[h_day]*2+1];
}
//**************************************
void clock_day_str(void){
	clock_in_lcd_gl(1);
	day_str();
}
//**************************************
void lcd_hh_mm(unsigned char *param){
	num2_bcd_in_lcd(4,*param);
	lcd_buffer[6]=font[f_seg_g];
	num2_bcd_in_lcd(7,*(param-1));
}
//**************************************
void num_month_day(void){//iln
	num2_bcd_in_lcd(1, hour[h_num]+1);
	lcd_buffer[3]=font[f_seg_d];
	num2_bcd_in_lcd(4, hour[h_month]+1);
	lcd_buffer[6]=font[f_seg_d];
	day_str();
}
//**************************************

//**************************************

void tempir_in_bcd(unsigned char t, unsigned char mesto, unsigned char pin_wire, unsigned char point){
unsigned char znak=0, n1=0,n2=0;

	if ( !(pin_wire & out_1wire) ){
	 	lcd_buffer[mesto]	=font[f_seg_g];
		lcd_buffer[mesto+1]	=font[f_seg_g];
		lcd_buffer[mesto+2]	=font[f_seg_g];
		}
		else
		{

	int te;
	te=((unsigned int)(tempir_msb[t]<<8))|tempir_lsb[t];//msb
	te=(te*10)>>4;

		if ( te<0 ){
			te*=-1;
			znak=1;
			}

		result_in_bcd(te);// 15.7 104.3 -55.2 5.2 -5.3
		
		if (setup.vid_t==0)
		{
			if ( bcd_num1 ) n1=font[bcd_num1];
			else 
			if (znak) 	n1=font[f_seg_g];
			n2=font[bcd_num2];
		} 
		else
		{
			if ( bcd_num1 ) {
			n1=font[bcd_num1];
			n2=font[bcd_num2];
			}
			else
			{
			if ( bcd_num2 ){ 
			n2=font[bcd_num2]; 
			if ( znak ) n1=font[f_seg_g];
			}
			else
			if ( znak ) n2=font[f_seg_g];
			}
		}
		
		lcd_buffer[mesto]=n1;
		lcd_buffer[mesto+1]=n2;
		lcd_buffer[mesto+2]=font[bcd_num3];
		lcd_buffer[mesto+3]=font[bcd_num4];
		
		if (point) lcd_buffer[mesto+2]|=font[tochka];
			else if (bcd_num4>5) lcd_buffer[mesto+2]|=font[tochka];
		}
}


//**************************************
void tempir__clock_in_lcd(void){
	lcd_buffer[3]=font[f_gr];
	clock_in_lcd_gl(4);
}
void tempir_1_clock_in_lcd(void){
	tempir_in_bcd(ds0,0, pwire0, false );
	tempir__clock_in_lcd();
}
void tempir_2_clock_in_lcd(void){
	tempir_in_bcd(ds1,0,pwire1, false);
	tempir__clock_in_lcd();
}
//**************************************/
void tempir_2_in_lcd(unsigned char point){
	tempir_in_bcd(ds0,0,pwire0, point);
	tempir_in_bcd(ds1,5,pwire1, point);
}
//**************************************/
void tempir_2o_in_lcd(void){//temp o temp
	tempir_2_in_lcd(true);
	lcd_buffer[4]=font[f_gr];
}

void tempir_2oo_in_lcd(void){//temp o temp
	tempir_2_in_lcd(false);
	lcd_buffer[3]=font[f_gr];
	lcd_buffer[8]=font[f_gr];
}
//**************************************/
void grad_celsia(void){
	lcd_buffer[7]=font[f_gr];
	lcd_buffer[8]=font[f_C];
}
//**************************************/
void one_tempir_0_in_lsd(void){
	tempir_in_bcd(ds0,2,pwire0,true);//012345678 //inl
	grad_celsia();
	lcd_buffer[0]=font[f_d]|font[tochka];
}
//**************************************/
void one_tempir_1_in_lsd(void){
	tempir_in_bcd(ds1,2,pwire1,true);//0-00.0 *c //inl
	grad_celsia();
	lcd_buffer[0]=font[f_y]|font[tochka];
}
//**************************************/
void clock_in_lcd1(void)
{
	num2_bcd_in_lcd(1,hour[h_hour]);
	blank_nul(1);
	lcd_buffer[3]=font[f_seg_g];
	lcd_hh_mm(&hour[h_min]);
}
//**************************************
void timer_in_lcd(void)
{
    if ( timer[3] & BIT(fl_timer_count) )	lcd_buffer[0]=font[f_t];
		else						 	lcd_buffer[0]=font[f_seg_d];
	num2_bcd_in_lcd(1,timer[h_hour]);
	lcd_buffer[3]=font[f_seg_g];
	lcd_hh_mm(&timer[h_min]);
}
void num_month_year_constructor(uint8_t znmesto, uint8_t zn_year){
	
	lcd_buffer[zn_year]=font[2];
	lcd_buffer[zn_year+1]=font[0];
	num2_bcd_in_lcd(zn_year+2,hour[h_year]);
	
	num2_bcd_in_lcd(znmesto,hour[h_num]+1);
	lcd_buffer[znmesto+1]|=font[tochka];
	num2_bcd_in_lcd(znmesto+2,hour[h_month]+1);
	lcd_buffer[znmesto+3]|=font[tochka];
}

void num_month_year(void){
	num_month_year_constructor(1,5);
}

void num_month_year_day(void){
	num_month_year_constructor(0,2);
	day_str();
}

void num_month_year_daynum(void){
	lcd_buffer[0]=font[hour[h_day]+1];
	num_month_year_constructor(2,4);
	lcd_buffer[8]=font[f_r]|font[tochka];
}

void num_month_year_g(void){
	num_month_year_constructor(1,3);
	lcd_buffer[7]=font[f_r]|font[tochka];
}

//*************************************
void power_in_lcd(unsigned char pin_wire, unsigned char mesto){
unsigned char a,b;
	if ( !(pin_wire & out_1wire) ){
		a=font[f_seg_g];
		b=font[f_seg_g];
		}
		else
		if (power_suplly_1w & pin_wire )
		{
		a=font[f_P];
		b=font[f_A];	
		}
		else{
		a=font[f_o];
		b=font[f_n];
		}
	lcd_buffer[mesto]=a;
	lcd_buffer[mesto+1]=b;
}


void view_in_indikator(unsigned char view){
  switch (view)
  {
    case (0): clock_in_lcd0(); 		break;//num,day, hour-min
    case (1): clock_in_lcd1();			break;//hour-min-sek
	case (2): clock_in_lcd_gl(2);		break;//hour-min
	case (3): clock_day_str();			break;//hour-min day
	case (4): num_month_day();			break;//num_month day
	case (5): num_month_year();		break;//31.12.2008
	case (6): num_month_year_day();	break;//31.12.08 CP
	case (7): tempir_2oo_in_lcd();		break;//00*  00*
	case (8): one_tempir_0_in_lsd();	break;// _ -000 *C 1
	case (9): one_tempir_1_in_lsd();	break;// _ -000 *C 2
	case (10): tempir_1_clock_in_lcd();break;// tempir0 hour-min
	case (11): tempir_2_clock_in_lcd();break;// tempir1 hour-min
	case (12): tempir_2o_in_lcd();		break;// 00.0 o 00.0
	case (13): tempir_2_in_lcd(true);	break;// -00 -00//
	case (14): num_month_year_daynum();break;//5 19.12.08.
    default: num_month_year_g();      	break;//19.12.08.
  }
}

void indikator_manager(void){
unsigned char i, a;

	a=i=current_state_view.regim;	//  
	if ( ++i>=Count_regim ) i=0; //     ,  .
	
	while ( i!=a )
		{
		if (current_state_view.regim==a)
			{
			if  (setup.state_time[i] > 0)
				{
				if (current_state_view.skip[i]) //   , 
					current_state_view.skip[i]--;//   	 
					else
					{
					current_state_view.regim=i;
					break;
					}
				}
			}
		if ( ++i>=Count_regim ) i=0;
		}
	
	i=current_state_view.regim;
	//if (i==a) 
	//i=0;//    ,    = 0
	current_state_view.time=		setup.state_time[i];
	current_state_view.skip[i]=		setup.state_skip[i];
	current_state_view.viewstate=	setup.state_regim[i];
}


void num3_th_in_lcd_buffer(unsigned char m){
	lcd_buffer[m]	=font[bcd_num2];
	lcd_buffer[m+1]	=font[bcd_num3];
	lcd_buffer[m+2]	=font[bcd_num4]|font[tochka];
}

//**************************************/
void data_lcd(void)
{
static uint8_t state_view_init=0;
 	cls_lcd_buffer();
	
	if (regim==0){
		if ( state_view_init ){
			state_view_init=0;
			current_state_view.viewstate= 0;
			current_state_view.time = 2;
			for(uint8_t i=0; i<Count_regim; i++)
					current_state_view.skip[i]=0;
			}
		if (eeprom_err){
			lcd_buffer[3]=font[f_E];
			lcd_buffer[4]=font[f_E];
			lcd_buffer[5]=font[f_P];
			}
			else
			{
			view_in_indikator(current_state_view.viewstate);
			}
		if (time_flag & fl_sig_otsr)  
			if (! (time_flag & fl_sek_1_switch) ) 
						lcd_buffer[8]|=font[tochka];
		return;
		}
		else{
		state_view_init=1;
		}
	
	if (regim==100){//       
		clock_in_lcd0();//    
		
		if (time_flag & fl_sig_otsr) lcd_buffer[3]=font[f_o];//if (time_flag & BIT(fl_otsrochka_signala)) 
		return;
		}
	
	if  (regim==3) {timer_in_lcd(); return;}
	
	if (regim==REG_BUDILNIK){//calls
		load_str_in_lcdbuffer1((prog_int8_t*)&str_calls);//
		return;
	    }
	if  (regim==REG_SETUP){//setup
		load_str_in_lcdbuffer1((prog_int8_t*)&str_setup[0]);
		return;
		}//*/
	if  (regim==REG_TIMER){//
		load_str_in_lcdbuffer1((prog_int8_t*)&str_timmer[0]);
		return;
		}
	
	// 
	if  (regim==REG_LIGHT){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_light[0]);
		return;
		}
	//light	
	if  (regim==11){
		lcd_buffer[0]=font[f_L];
		if (setup.day_light>=sizeof(light_disp)-1) setup.day_light=sizeof(light_disp)-1;
	    for(uint8_t i=0; i<setup.day_light; i++)
			lcd_buffer[i+1]=font[f_o];
		lcd_light=setup.day_light;
		return;
		}
	if  (regim==14){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_light_noch[0]);
		lcd_buffer[7]=font[setup.night_light];
		lcd_light=setup.night_light;
		return;
		}// end light
	if  ( (regim>14)&&(regim<17) ){
		lcd_buffer[1]=font[f_c];
		num2_bcd_in_lcd(2,setup.tim_c_light);
		lcd_buffer[5]=font[f_d];
		lcd_buffer[6]=font[f_o];
		num2_bcd_in_lcd(7,setup.tim_do_light);
		return;
		}// end light
	
	
	//----------------------------
	if (regim==REG_CLOCK){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_clock[0]);
		return;
	    }
	if ( ( regim>=r_clock )&&( regim<=r_clock+2 ) ){
		clock_in_lcd1();//hour-min-sek  
		return;
	    }
	if ( ( regim>=r_clock+3 )&&( regim<=r_clock+6 ) ){
		num_month_year_day();
		return;
	   	}

	if ( ( regim>=r_clock+7 )&&( regim<=r_clock+8 ) ){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_corr[0]);
		if ( setup.corr_flag&BIT(fl_corr_znak_pl) ) lcd_buffer[4]=font[f_seg_d]; 
	   	  else 							   	 lcd_buffer[4]=font[f_seg_g];   
		lcd_buffer[5]=font[n0]|font[tochka];

		result_in_bcd( pgm_read_word_near(&corr_in_lcd[setup.correction]) );
		lcd_buffer[6]	=font[bcd_num2];
		lcd_buffer[7]	=font[bcd_num3];
		lcd_buffer[8]	=font[bcd_num4];
		return;
		}	

	// 
	if ((regim>30)&&(regim<35)){
	   	lcd_buffer[0]=font[budilnik_nomer];
		lcd_hh_mm(&setup.budilnik[ budilnik_nomer ] [c_hour]);
		lcd_buffer[1]=sig_bud_str[ setup.budilnik[ budilnik_nomer ][c_sig] ][0];
		lcd_buffer[2]=sig_bud_str[ setup.budilnik[ budilnik_nomer ][c_sig] ][1];
		if (( budilnik_nomer >= 8 )&&( budilnik_nomer <= 9 )) {if (!nedelia[budilnik_nomer-8]) lcd_buffer[3]=font[f_gr]; else lcd_buffer[3]=font[f_seg_d];}
		return;
		}	
	if ((regim>44)&&(regim<48)){
		num2_bcd_in_lcd(1,setup.budil_pin[budilnik_nomer-10][h_hour]);
		lcd_buffer[3]=font[f_seg_g];
		lcd_hh_mm(&setup.budil_pin[budilnik_nomer-10][h_min]);
		return;
		}	
	if ((regim>34)&&(regim<42)){
	    lcd_buffer[0]=font[f_d]|font[tochka];
		for (uint8_t i=0; i<7; i++){
			if ((setup.budilnik[ budilnik_nomer ][c_day])&BIT(i))
			lcd_buffer[i+2]=font[i+1]; else lcd_buffer[i+2]=font[f_seg_d];
			}
		return;
		}
	//--SIGNAL--
	if (regim==REG_SIGNAL){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_signal[0]);
		return;
	    }
	if (regim==reg_signal){
		if (p_index==0)	load_str_in_lcdbuffer1((prog_int8_t*)&str_budil[0]); 
		else				load_str_in_lcdbuffer1((prog_int8_t*)&str_button[0]);	
		lcd_buffer[8]=font[f_S];
		return;
		}
	if ((regim>reg_signal)&&(regim<reg_signal+3)){
		
		if ( p_index == 0 ){
			signal=sig_on;
			time_signal=10;
			time_flag|= fl_signal_out_enable;
			}
		
		lcd_buffer[0]=font[f_H];
		result_in_bcd(setup.ocr1[p_index*2]);
		num3_th_in_lcd_buffer(1);
		lcd_buffer[5]=font[f_L];
		result_in_bcd(setup.ocr1[p_index*2+1]);
		num3_th_in_lcd_buffer(6);
		return;
		}
	//--END--SIGNAL--

	//   
	if (regim==REG_SBROS_N){// 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_default[0]);
		return;
	    }
	// 
	if (regim==REG_PORT){//
		load_str_in_lcdbuffer1((prog_int8_t*)&str_port[0]);
		return;
	    }
	if ( regim==71 ){//
		load_str_in_lcdbuffer1((prog_int8_t*)&str_pin_c[0]);
		if (PINC & PIN_calls1) lcd_buffer[7]=font[1]; else lcd_buffer[7]=font[0];
		return;
	   	}
	//===============================
	if ( regim==REG_YST_BUD ){//  _yct_bud_ 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_yst_bud[0]);
		return;
	    }
	if (regim==75){ //CAL. bIP C 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_sig_budil[0]);
		
		uint8_t *p;
		p=(uint8_t*)yst_bud_str+setup.signal_bud*3;

		lcd_buffer[6]=*p;
		lcd_buffer[7]=*(p+1);
		lcd_buffer[8]=*(p+2);
		
		//lcd_buffer[6]=yst_bud_str[setup.signal_bud][0];
		//lcd_buffer[7]=yst_bud_str[setup.signal_bud][1];
		//lcd_buffer[8]=yst_bud_str[setup.signal_bud][2];
		return;
	    }
	
		
	if 	((regim>79)&&(regim<84)) {timer_in_lcd(); return;}
	
	if (regim==REG_YST_SEE){//t see	
	    load_str_in_lcdbuffer1((prog_int8_t*)&str_yst_see[0]);
		return;
	    }
	if ((regim>90)&&(regim<95)) {

		lcd_buffer[0]=font[current_state_view.regim+1];
		lcd_buffer[1]=font[f_r];//|font[tochka];
		lcd_buffer[2]=font[setup.state_regim[current_state_view.regim] ];//|font[tochka];
		lcd_buffer[4]=font[f_c];
		num2_bcd_in_lcd(5,setup.state_time [current_state_view.regim]);
		
		lcd_buffer[7]=font[f_n];//|font[tochka];
		lcd_buffer[8]=font[setup.state_skip [current_state_view.regim] ];//|font[tochka];
		
		//lcd_buffer[8]^=font[tochka];

		return;
		}
	
	if (regim==REG_DS18B20){//d, S, 1, 8, b, 2, 0, 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_ds18b20[0]);
		return;
		}
	if (regim==111){// on on
		if (setup.vid_t==0) 
			load_str_in_lcdbuffer1((prog_int8_t*)&str_vid1_t[0]);
			else
			load_str_in_lcdbuffer1((prog_int8_t*)&str_vid2_t[0]);
		//load_str_in_lcdbuffer1((prog_int8_t*)&str_pit[0]);
		//power_in_lcd(pwire0, 4);
		//power_in_lcd(pwire1, 7);
		return;
		}
	if (regim==112){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_pit[0]);
		power_in_lcd(pwire0, 4);
		power_in_lcd(pwire1, 7);
		return;
		}

	if (regim==REG_SAVE_SETUP) {
		load_str_in_lcdbuffer1((prog_int8_t*)&str_save_eeprom[0]);
		return;
		}
	
	if (regim==150){// 
		if (time[beg_str]<=0){
			time[beg_str]=45;
			simvol++;
			if (simvol==str_length+9) simvol=0;
			}
		for (uint8_t a=0, i=simvol; a<9 ; i++, a++){
				if ( (i>8)&&(i<str_length+9) )
					lcd_buffer[a]=*(ukaz_na_str+i-9);//str[i-9];
			}
		}
}
//**************************************
void str_init(void){
unsigned char h;
	//0-5; 6-11; 12-17; 18-23;
	
	h=hour[h_hour];
	if (h<6)	ukaz_na_str=&str_noch[0];	else
	if (h<12)	ukaz_na_str=&str_utro[0];	else
	if (h<18)	ukaz_na_str=&str_day[0];	else
				ukaz_na_str=&str_vecher[0];

	*(ukaz_na_str+5)=font[budilnik_nomer];
	result_in_bcd(hour[h_hour]);
	*(ukaz_na_str+7)=font[bcd_num3];
	*(ukaz_na_str+8)=font[bcd_num4];
	result_in_bcd(hour[h_min]);
	*(ukaz_na_str+10)=font[bcd_num3];
	*(ukaz_na_str+11)=font[bcd_num4];
}

//**************************************
void init_signal(void){
	str_init();
	count_note=0;
	simvol=0;
	time[note]=3;
	time_signal=59;
	time_in_regim=59;
	time_flag &=~  fl_signal_cls;
	time_flag |=   fl_signal_out_enable;
}

void shim(void){
unsigned char tmp;
	if (time[note]<=0)
		{
		tmp=uprav_TCCR1B[count_note];
		if (tmp&0x01)	timer1_init_in_pwm();
			else		timer1_init();
		time[note]=length_note[count_note];
		TCCR1B=tmp;
		if (++count_note==4) count_note=0;
		}
}

void budilnik_out(void){
if (!setup.signal_bud){
	shim();
	}
	else 
	if (setup.signal_bud==1){
		PORT_OUT|=PIN_calls_osn;	
		}
	else{
	shim();
	PORT_OUT|=PIN_calls_osn;
	}
}
//*************************************
void signal_off(void)
{
//   ---------------------------
	if ( time_signal==0 )
	{	
		if (signal==0) //   
		{
		if (time_flag & fl_sig_otsr) //   
			{
			if ( ++budilnik_play_num==8 ) {//  .  7 , //
				time_flag &= ~fl_sig_otsr;
				}
				else{//   ,   ,   
				init_signal();
				regim=150;
				signal=sig_on_otsr;
				return;//   
				}
			}
		}
		else
		if (signal<sig_foreva) time_flag |= fl_signal_cls;
	}

//  
	if ( !(time_flag & fl_sig_butt) )
	if ( time_flag & fl_signal_cls )//  
		{
		time_flag &=~  (fl_signal_cls|fl_signal_out_enable);
			
		PORT_OUT &=~  PIN_calls_osn;
		PORT_OUT &=~  PIN_timer;
		timer1_init();
		
		time_signal=0xFF;	
		
		if (signal==sig_odnorazovoi) setup.budilnik[budilnik_nomer][c_sig]=0;
			
		signal=0;
		}
}

//*************************************


//**************************************/
void calls_verify(void)
{
unsigned char i;
	for(i=0;i<12;i++)
		if ( setup.budilnik[i][c_sig] )//  
		  if ( BIT(hour[h_day])&setup.budilnik[i][c_day] )// 
		   	if (setup.budilnik[i][c_hour]==hour[h_hour])//
			  if (setup.budilnik[i][c_min]==hour[h_min])//
				{
				if (i<8){
					budilnik_nomer=i;
					signal=setup.budilnik[i][c_sig];
					if (signal==sig_on_otsr ) time_flag |= fl_sig_otsr;
					budilnik_play_num=0;//           
					init_signal();
					regim=150;
					} 
					else
				if (i<10){
					if ( (nedelia[i-8] & _BV(0))==0 ){
						budilnik_nomer=i;
						signal=setup.budilnik[i][c_sig];
						if (signal==sig_on_otsr ) time_flag |= fl_sig_otsr;
						budilnik_play_num=0;//           
						init_signal();
						regim=150;
						}
					}
					else{//  

					uint8_t c=i-10;
					time_bud_pin=setup.budil_pin[c][h_hour]*3600+setup.budil_pin[c][h_min]*60+setup.budil_pin[c][h_sek];
					if (time_bud_pin){
						time_flag|=fl_calls_pin_A_on;
						PORT_OUT|= PIN_calls1 ;
						}
					}
				}
}
//**************************************
void calls_pin_verify(void){

	if ( time_flag & fl_calls_pin_A_on )
	{
	if (--time_bud_pin==0xFFFF)
		{
		PORT_OUT&=~ PIN_calls1 ;
		time_flag &=~ fl_calls_pin_A_on;
		}
	}
}
//*/
//**************************************
void timer_verify(void){
	if (timer[3]&BIT(fl_timer_count) )//yst bit 0 dlia schet enable
	{
	if		(!timer[h_hour])
	 if 	(!timer[h_min])
	  if	(!timer[h_sek])	
		{
		timer[3]&=~BIT(fl_timer_count) ;
		signal = sig_timer;
		regim=80;
		init_signal();	
		PORT_OUT|= PIN_timer ;
		return;
		}
	if ( --timer[h_sek]<0 ){
	  	timer[h_sek]=59;
		timer[h_min]--;
		if ( timer[h_min]<0 ){
		 	timer[h_min]=59;
			timer[h_hour]--;
			}
		}
	}
}
//**************************************


//**************************************
void clock(void){

  if ( isr_1sek_ )// 
	{
	correct=0;
	if (++hour[h_sek]==60)
		{
		if (++hour[h_min]==60)
			{
			if ( setup.corr_flag&BIT(fl_corr_znak_pl) )// 
				correct=setup.correction;// 
				else
				correct= 0x00-setup.correction;
			
			hour[h_min] =0;
			hour[h_hour]++;
		
			if (hour[h_hour]==24)
				{
				hour[h_hour]=0;
				hour[h_day]++;
				hour[h_num]++;
				if (hour[h_day]>7-1)	{hour[h_day]=0; nedelia[0]^=_BV(0);nedelia[1]^=_BV(0);}
				if (hour[h_num]> (num_in_month[hour[h_month]]-1 ) )////!!!
					{
					hour[h_num]=0;
					hour[h_month]++;
					if (hour[h_month]>11) 	{hour[h_month]=0; hour[h_year]++;}
					}
				}
			if ( hour[h_hour] == setup.tim_c_light)	lcd_light=setup.night_light;
			if ( hour[h_hour] == setup.tim_do_light)	lcd_light=setup.day_light;
			}
		hour[h_sek] =0;
		calls_verify();
		}
	isr_1sek_=0;
	}
}
//****************************************

void time_direct(void){
static unsigned char t, sek;

	if ( t != clock_ )
		{//  0,0078125 .
		t=clock_;
		
		if (t>=64) time_flag|=fl_sek_1_switch; else time_flag&=~fl_sek_1_switch;
		for ( uint8_t i=0; i<4; i++) time[i]--;
		
		if ( time_flag & fl_sig_butt )
			if (time[note_but]<0)
			{
			time_flag&= ~ fl_sig_butt;
			timer1_init();
			}
	
		if ( sek!=hour[h_sek] ){// 
			sek=hour[h_sek];
			if (regim==0)
				if (--current_state_view.time == 0 ) indikator_manager();
			if (--time_in_regim == 0 )
						if (regim>=4) regim=0;
			time_signal--;
			timer_verify();
			calls_pin_verify();// 
			}

		//  
		signal_off();
		if (time_flag&fl_signal_out_enable) budilnik_out();//       
		
		if (time_flag&fl_power_init_device)//   
			skankey();
		
		if (regim>=4)//if (mask)
			{
			static uint8_t time_mig=0;
			if (++time_mig>=light_time_mig[lcd_light])//(10-lcd_light)
				{
				time_mig=0;
				change_light_var();
				}
			}
		}
}
//---------------------------------------------------------
void init_devices_save_mode(void)
{
	TIMSK =(1<<TOIE2);
	PORTLCD=0;// 
	PORTID |= pin_id;// 10  Z 
	PORT_VCC_ID &= ~PIN_VCC_ID;//   10
}
//---------------------------------------------------------


int main(void)
{
	cli();
	read_data_EEPROM();
	
	timer2_init();
	init_devices();

while(1)
 {//while
   clock();
   if (!pin_power_)
	{//begin power on
	 	if (time_flag&fl_power_init_device)
			{
			time_flag&=~fl_power_init_device;
			init_devices();
			current_state_view.time=2;
			time_in_regim=2;
			}
		/* */  
		
		time_direct();
		
		if (lcd_time_switch>=30)/* 2msek*/ 
	  	   	{
			lcd_time_switch=0x00;
  	   		if  (++znakomesto<9) {
				light_isr=light_disp[opred_light_current_num()];

				skankey();
				display();
				key_action();
				}
				else	
				{
				PORTID|=pin_id; //  	

				if (regim){
					uint8_t l=setup.day_light;
					if ( setup.tim_do_light > setup.tim_c_light )
						{
						if ( (hour[h_hour] < setup.tim_do_light )&&( hour[h_hour] >= setup.tim_c_light ) ) 
							l=setup.night_light; else l=setup.day_light;
						}
						else
						{
						if ( (hour[h_hour] >= setup.tim_do_light )&&( hour[h_hour] < setup.tim_c_light ) ) 
							l=setup.day_light; else l=setup.night_light;
						}
					lcd_light=l;
					}
				data_lcd();
				znakomesto=0xFF;
				lcd_time_switch=25;

				}
	  		}
		if (lcd_time_switch<5) izmerenie_t();	/* */
		
	}//end power on
	 else
	{//begin power off
	if (!(time_flag&fl_power_init_device))
		{
		time_flag|=fl_power_init_device;
		init_devices_save_mode();
		}
	
	time_flag &= ~fl_sig_otsr;//    
	
	if ( signal || ( time_flag & fl_sig_butt ) )//          
		{
		time_direct();
		if (key!=17){
			time_flag |=  fl_signal_cls;
			time_flag &= ~fl_signal_out_enable;
			//if (F_) time_flag &= ~fl_sig_otsr;
			}
		}
		else
		{//        
		MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
		asm("sleep");
		MCUCR=0;
		}

/*
static unsigned char s,a;
de:
a=clock_;
if (a==s) goto de;
s=a;
//*/
	
	}//end power off
 }//while

}
